
package com.magelang;

import java.awt.Component;
import java.awt.Button;
import java.awt.Graphics;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
/**
 * <p>Use this code at your own risk!  MageLang Institute is not
 * responsible for any damage caused directly or indirctly through
 * use of this code.
 * <p><p>
 * <b>SOFTWARE RIGHTS</b>
 * <p>
 * MageLang support classes, version 1.0, MageLang Institute
 * <p>
 * We reserve no legal rights to this code--it is fully in the
 * public domain. An individual or company may do whatever
 * they wish with source code distributed with it, including
 * including the incorporation of it into commerical software.
 *
 * <p>However, this code cannot be sold as a standalone product.
 * <p>
 * We encourage users to develop software with this code. However,
 * we do ask that credit is given to us for developing it
 * By "credit", we mean that if you use these components or
 * incorporate any source code into one of your programs
 * (commercial product, research project, or otherwise) that
 * you acknowledge this fact somewhere in the documentation,
 * research report, etc... If you like these components and have
 * developed a nice tool with the output, please mention that
 * you developed it using these components. In addition, we ask that
 * the headers remain intact in our source code. As long as these
 * guidelines are kept, we expect to continue enhancing this
 * system and expect to make other tools available as they are
 * completed.
 * <p>
 * The MageLang Support Classes Gang:
 * @version MageLang Support Classes 1.0, MageLang Insitute, 1997
 * @author <a href="http:www.scruz.net/~thetick">Scott Stanchfield</a>, <a href=http://www.MageLang.com>MageLang Institute</a>
 */
class TabLabelPanel extends java.awt.Panel implements ActionListener {
	private TabSplitter masterPanel;
	private Button nameButton;
	private Component comp;

public TabLabelPanel(String text, Component c, TabSplitter t) {
	masterPanel = t;
	comp = c;
	nameButton = new Button(text);
	nameButton.addActionListener(this);
	setName("TabLabelPanel");
	setLayout(new java.awt.BorderLayout());
	setBackground(java.awt.Color.lightGray);
	BorderPanel b = new BorderPanel();
	b.add("Center", nameButton);
	add("North", b);
	add("Center", c);
}
public void actionPerformed(ActionEvent e) {
	masterPanel.separateTabs(this);
}
public Component getComponent() {
	return comp;
	}
public String getTabName() {return nameButton.getLabel();}
public Component removeComponent() {
	remove(comp);
	return comp;
}	
public void setTabPanel(TabSplitter panel) {
	masterPanel = panel;
}	
}