
package magercises.qstack.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.util.Vector;
import java.util.Enumeration;

class QStack implements Stack, Queue {

  private Vector items = new Vector(10);


  /** add to end of vector, which is end of queue */
  public void add(Object o) {
	items.addElement(o);
  }    
  /** remove item from end of vector, which is top of stack */
  public Object pop() {
	Object item = items.lastElement();
	items.removeElementAt(items.lastIndexOf(item));
	return item;
  }    
  /** add to end of vector, which is top of stack */
  public void push(Object o) {
	items.addElement(o);
  }    
  /** remove from front of vector, which is front of queue */
  public Object remove() {
	Object item = items.firstElement();
	items.removeElementAt(items.indexOf(item));
	return item;
  }    
  public String toString() {
	StringBuffer buff = new StringBuffer(100);
	buff.append("A QStack, elements: ");
	
	Enumeration enum = items.elements();
	while(enum.hasMoreElements()) {
	  buff.append(enum.nextElement().toString() + " ");
	}
	return buff.toString();
	
  }    
}