
package magercises.syncstmt.solution;


/* 
   Simple use of synchronized stmts to avoid an invalid
   state in an object by serializing access to it.

   Given Announce Box and SynchTestApplet, write a 
   Speaker object that uses synch stmts to control
   access to the announcebox.  Demonstrate both
   protected and unprotected access.

*/

import java.awt.*;
import java.applet.Applet;
import java.util.Date;

class AnnounceBox extends TextArea {


  public AnnounceBox() {
	super("",15,40);
  }    
  public void announce(String s) {
	setText(getText() + s);
  }    
}