
package magercises.waitstack.solution;

/* 
   A modification of SimpleStack, WaitStack makes callers to pop
   wait when the stack is empty.  When a new item is pushed onto
   the stack, the waiting threads will be notified.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class StackPopper extends Thread {
  WaitStack stack;
  StackTest stackTestApplet;


  public StackPopper(WaitStack s, StackTest a) {
	stack = s;
	stackTestApplet = a;
  }    
  public void run() {
	for(int i = 0; i < 5; i++) {
	  stack.pop();
	}
	stackTestApplet.threadDone("StackPopper");
  }    
}