
package magercises.waitstack.solution;

/* 
   A modification of SimpleStack, WaitStack makes callers to pop
   wait when the stack is empty.  When a new item is pushed onto
   the stack, the waiting threads will be notified.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class StackPusher extends Thread {
  Object item;
  WaitStack stack;
  StackTest stackTestApplet;


  public StackPusher(Object o, WaitStack s, StackTest a) {
	item = o;
	stack = s;
	stackTestApplet = a;
  }    
  public void run() {
	for(int i = 0; i < 10; i++) {
	  stack.push(item);
	}
	stackTestApplet.threadDone("StackPusher");
  }    
}