
package magercises.cats.solution;


/* 
	Use the WaitStack (a blocking stack) to act as an argument stack
	for a simple consumer.  Here the consumer, CatMachine, waits until
	it can pull out some number of objects from its input stack, cats
	them together as strings, then sends it to it's output, which is
	another consumer.  A new subclass of TextArea is introduced to 
	act as a final consumer and show the output.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

class ConsumerTextArea extends TextArea implements Consumer {


  public ConsumerTextArea(int rows, int cols) {
	super(rows,cols);
  }    
  public void inputItem(Object o) {
	setText(o.toString());
  }    
}