
package magercises.facade.solution;


/* Using a facade w/ sync methods
   There are two entities with a 1 - 1 relationship, a person
   to a locker,  the registrar object handles reassignment of 
   persons to locker, this avoids potential deadlock.
   (ref. integrity requires that old owner of locker must
   be updated to null)
   (make registration a static method ?)
   how to make live?

*/

import java.awt.*;
import java.applet.Applet;


class Locker {
  Person owner;
  String code;


  public Locker(String s) {
	code = s;
  }    
  public String getCode() {
	return code;
  }    
  public Person getOwner() {
	return owner;
  }    
  public String toString() { 
	return "Locker: " + code + " with owner " 
	  + (owner == null ? "none" : owner.getName());
  }    
}