
package magercises.fetchurl.solution;


/* 

  Spawn a thread to fetch a url.

*/

import java.awt.*;
import java.io.DataInputStream;
import java.net.URL;
import java.applet.Applet;

class URLFetchPanel extends Panel implements Runnable {
  Panel getPanel;
  TextField urlField;
  Button getButton;
  TextArea output;
  Thread fetchThread;


  public URLFetchPanel() {
	setLayout(new BorderLayout());
	getPanel = new Panel();
	getPanel.add(urlField = new TextField(30));
	getPanel.add(getButton = new Button("Get URL"));
	add("North",getPanel);
	add("Center",output = new TextArea(10,45));
	validate();
  }    
  public boolean action(Event evt, Object arg) {
	if(evt.target == getButton) {
	  fetchThread = new Thread(this);
	  fetchThread.start();
	  return true;
	}
	return false;
  }    
  public void run() {
	 StringBuffer buf = new StringBuffer(1000);
	 String temp;
	  try {
	URL theURL = new URL(urlField.getText());
	DataInputStream inStream = new DataInputStream(theURL.openStream());
	System.out.println("got url");
		while((temp = inStream.readLine()) != null) 
	   buf.append(temp);
		output.setText(buf.toString());
		System.out.println(temp);
		output.repaint();
	  } catch (Exception e)  { System.out.println("exception: " + e); }
  }    
}