
package magercises.inheritance.solution;

class Company extends NamedEntity {
  Employee employees[] = new Employee[3];
  int numEmployees = 0;


  public Company(String aName) {
	super(aName);
  }    
  public void addEmployee(Employee e) {
	if(numEmployees == employees.length) {
	  Employee temp[] = new Employee[employees.length * 2];
	  System.arraycopy(employees, 0, temp, 0, employees.length);
	  employees = temp;
	}
	employees[numEmployees] = e;
	numEmployees++;
  }    
  public String toString() {
	StringBuffer buf = new StringBuffer(100);

	buf.append("Company: " + getName() + "\nEmployees:\n");
	for(int i = 0; i < numEmployees; i++) {
	  buf.append(employees[i].toString() + "\n");
	}
	return buf.toString();
  }    
}