
package magercises.singleton.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.util.Vector;
import java.util.Enumeration;


class PersonFactory {
  static PersonFactory instance;


  private PersonFactory() { }    
  public static PersonFactory instance() {
	if(instance == null)
	  instance = new PersonFactory();
	return instance;
  }    
  public Person newPerson(String aName) {
	return new Person(aName);
  }    
}