
package magercises.syncstmt.solution;


/* 
   Simple use of synchronized stmts to avoid an invalid
   state in an object by serializing access to it.

   Given Announce Box and SynchTestApplet, write a 
   Speaker object that uses synch stmts to control
   access to the announcebox.  Demonstrate both
   protected and unprotected access.

*/

import java.awt.*;
import java.applet.Applet;
import java.util.Date;

public class SynchStmtTest extends Applet {
  AnnounceBox box;  
  String stmts1[] = { "It ", "is ", "not ", "easy ", 
					  "to ", "wreck ", "a ", "nice ", "beach ", "\n" };
  String stmts2[] = { "Visualize ", "whirled ", "peas ", "\n" };


  public SynchStmtTest() {
	setLayout(new FlowLayout());
	add(box = new AnnounceBox());
  }    
  public void start() {
	new Speaker(box, stmts1).start();
	new Speaker(box, stmts2).start();
  }	    
}