
package magercises.throwclause.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.


/** 
This file is the solution for the following scenario:

You are a quality control engineer at an airplane manufacturer.  You
are building a computer simulation of airplane construction.  In order
to best study error handling at the factory, you are using Java 
exceptions to track errors in the factory.  

The following program
is a skeleton of factory processes.  Annotate the code to raise
exceptions when one of the process ares is faulty (such as if
badEngines is true).  Catch all exceptions as soon as possible.
Also raise a ComponentException if one of the component build
processes (for engine and frame) is faulty. Whenever an exception
is caught, print out an appropriate error message.

*/

class AssemblyException extends Exception { 
}