
package magercises.url.solution;

// Copyright 1996, <a href=http://www.MageLang.com>MageLang Institute</a>.

import java.net.*;
import java.io.*;
import java.awt.Label;
import java.awt.BorderLayout;

public class URLTest extends java.applet.Applet {
	java.awt.TextArea ta;

	public void displayFile(DataInputStream in) {
		try {
			String line = in.readLine();
			while (line!=null) {
				ta.appendText(line+"\n");
				line = in.readLine();
			}
		}
		catch (EOFException e) {
			// no problem, end of file here
		}
		catch (IOException e) {
			ta.appendText("IO error reading file");
		}
	}
	public void init() {
		setLayout(new BorderLayout());
		try {
			String urlName = getParameter("url");
			URL url;

			if ( urlName==null ) {
				urlName = "http://www.magelang.com/index.html";
				url = new URL(urlName);
			}
			else {
				url = new URL(urlName);
			}
			System.err.println("url made");
			ta = new java.awt.TextArea(10,70);
			add("North", new Label("Contents of: "+urlName));
			add("Center",ta);
			System.err.println("text area made");
			InputStream in;
			in = url.openStream();
			if ( in==null ) {
				System.err.println("Cannot open stream to file!");
				ta.appendText("Cannot open stream to file!");
			}
			else {
				DataInputStream df = new DataInputStream(in);
				displayFile(df);
				df.close();
			}
		}
		catch (Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
	}
}