
package magercises.waitstack.solution;

/* 
   A modification of SimpleStack, WaitStack makes callers to pop
   wait when the stack is empty.  When a new item is pushed onto
   the stack, the waiting threads will be notified.
*/

import java.awt.*;
import java.applet.Applet;
import java.util.Vector;

public class StackTest extends Applet {
  TextArea output;
  WaitStack theStack;


  public void init() {
	setLayout(new FlowLayout());
	add(output = new TextArea(5,50));
  }    
  public void start() {
	theStack = new WaitStack();
	StackPusher bob = new StackPusher("bob",theStack,this);
	StackPopper joe = new StackPopper(theStack,this);
	bob.start();
	joe.start();
  }    
  /** print out the state of the stack. */
  public synchronized void threadDone(Object o) {
	output.setText(output.getText()
		   +  o.toString() + " done, \nstack: " 
		   + theStack.toString() + "\n");
  }    
}